'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///
'//////////////////////////////////////////////////////////
$Device= 8515				' used device
$Stack = 32                	' stack size
$Clock = 8

$GLCD HD61202, data=PORTA, ctrl=PORTC, 128, 64, 2
$Gctrl CS1=1, CS2=0, DI=2, WR=3, EN=4
$Source= On

Dim x As Byte, y As Byte
Dim r As Byte
Dim s As String*20
Dim n As Byte, m As Byte, adr As Word
Dim Lines As Flash Byte
Dim Cyclo As Flash Byte
Dim Icons As Flash Byte
Dim FastAvr As Flash Byte
Dim BigNum As Flash Byte
Dim Arrows As Flash Byte
Dim F0HD As Flash Byte
Dim F1HD As Flash Byte

Declare Sub Circles(xc As Byte, yc As Byte, rc As Byte)
Declare Sub BigN()

Set DDRC.5
Set PORTC.5

GLcdInit
Do
	ImgSet(0,0), FastAvr		' first Img
	For n=0 To 100              ' count to 100
		BigN()                  ' with BigNums (ImgArray)
		WaitMs 250
	Next 
	For n=0 To 31               ' arrows from ImgArray
		m=n mod 4
		ImgSet(10,4,m),Arrows
		ImgSet(94,4,m),Arrows
		WaitMs 250
	Next         
	Wait 3
	Gcls    
	LineH(0,0,127),1			' box arround LCD
	LineH(0,63,127),1
	LineV(0,0,63),1
	LineV(127,0,63),1
	Circles(63,31,30)			' some 
	Circles(83,27,20)
	Circles(113,51,10)
	Circles(43,15,14)
	Circles(23,40,18)
	Wait 3
	ImgSet(0,0),Lines			' some Images    
	Wait 3
	ImgSet(0,0),Cyclo    
	Wait 3
	ImgSet(0,0),Icons    
	Wait 3
	Gcls
	FontSet F0HD                  
	For n=0 To 7				' test 6x8 soft fonts
		GLcd(n*4,n), "0123456789012345"
	Next
	Wait 3
	Gcls
	FontSet F1HD				' test 8x8 soft fonts                  
	For n=0 To 7
		GLcd(0,n), "0123456789012345"
	Next      
	Wait 3
Loop

$Include "c:\FastAVR\Lines.bas"
$Include "c:\FastAVR\Cyclo.bas"
$Include "c:\FastAVR\Icons.bas"
$Include "c:\FastAVR\FastAvr.bas"
$Include "c:\FastAVR\BigNum.bas"
$Include "c:\FastAVR\Arrows.bas"
$Include "c:\FastAVR\F0HD.bas"
$Include "c:\FastAVR\F1HD.bas"

'//////////////////////////////////////////////////////////
Sub Circles(xc As Byte, yc As Byte, rc As Byte)
Local xx As Byte, yy As Byte, tr As Integer
Local dd As Byte
Local a As Byte, b As Byte, c As Byte, d As Byte

dd=yc-xc
xx=0: yy=rc
tr=3-2*rc
While xx<=yy
	a=xc+xx: b=yc+yy
	c=xc-xx: d=yc-yy
	Pset(a,b),1
	Pset(a,d),1
	Pset(c,b),1
	Pset(c,d),1
	a=yc+yy-dd: b=yc+xx
	c=yc-yy-dd: d=yc-xx
	Pset(a,b),1
	Pset(a,d),1
	Pset(c,b),1
	Pset(c,d),1
	If tr<0 Then
		tr=tr+4*xx+6
	Else
		tr=tr+4*(xx-yy)+10
		Decr yy
	End If 
	Incr xx
Wend
End Sub
 
'//////////////////////////////////////////////////////////
Sub BigN() 
Local i As Byte, j As Byte

s=Str(n)
i=0
adr=VarPtr(s)
Do
	j=Peek(adr)
	If j Then
		Incr adr
		ImgSet(i*16+40,4,j-48),BigNum
		Incr i
	Else
		Exit Do
	End If
Loop
End Sub
 