'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///
'//////////////////////////////////////////////////////////
$Device= 8515				' used device
$Stack = 32                	' stack size
$Clock = 8
$Timer1=Timer, Prescale=256
$GLCD HD61202, data=PORTA, ctrl=PORTC, 128, 64, 2
$Gctrl CS1=1, CS2=0, DI=2, WR=3, EN=4
$1Wire=PORTD.2
$Source= On

Dim T As Word, xx As Byte, tt As Byte
Dim d0 As Byte, d1 As Byte, d2 As Byte, d3 As Byte
Dim d4 As Byte, d5 As Byte, d6 As Byte, d7 As Byte
Dim crc As Byte, present As Byte 
Dim s As String*3, adr As Byte
Dim a As Bit, b As Bit, n As Byte
Dim BigNum2 As Flash Byte
Dim Xaxis As Flash Byte
Dim Yaxis As Flash Byte

Declare Sub BigN()
Declare Sub Read1820()
Declare Sub CalcTmp()
Declare Interrupt Ovf1()

Set DDRC.5
Set PORTC.5 				' reset for LCD

GLcdInit
Gcls
ImgSet(0,0),Yaxis    		' draw Y axis
ImgSet(9,7),Xaxis			' draw X axis
For xx=9 To 126 Step 3 		' draw grid
	Pset(xx,16),1
	Pset(xx,36),1
Next
Pset(118,16),1 				' draw decimal point
Pset(118,17),1
Pset(118,18),1
	
xx=9: n=0 
Enable Interrupts
Enable Timer1
Start Timer1

Do
	If b=1 Then            		' if is time
		b=0
		present=1Wreset			' test for presence
		If present=1 Then
			1Wwrite &hcc; &h44
			WaitMs 250
			1Wreset
			1Wwrite &hcc; &hbe
			Read1820()  		' read sensor
			If a=1 Then   		' if time to draw point
				a=0
				Pset(xx,tt),1	' draw point
				Incr xx
				If xx=126 Then xx=9	' another screen
			End If
		End If
	End If
Loop

$Include "c:\FastAVR\BigNum2.bas"
$Include "c:\FastAVR\Xaxis.bas"
$Include "c:\FastAVR\Yaxis.bas"

'/////////////////////////////////////////////////////
Interrupt Ovf1(), Save 1
Timer1=&h85ee		' 1sec interrupt
'Timer1=&h0bdc		' 2sec interrupt
'Timer1=&h676a		' 5sec interrupt (prescale=1024!)
Incr n				' sec counter
b=1					' flag for seconds
If n=2 Then			' long time
	a=1				' flag for long time
	n=0
End If
End Interrupt

'/////////////////////////////////////////////////////
Sub Read1820()

1Wread d0,9       		' reaall 9 bytes
If Crc8(d0,9)=0 Then  	' calc CRC
	CalcTmp()
End If
End Sub

'/////////////////////////////////////////////////////
Sub CalcTmp()

If (d0 And 1)=1 Then
	Decr d0
End If
T=(50*d0-25+(100*(d7-d6))/d7)/10
BigN()								' T is 10*bigger

T=(T-100)/5				' calculate for coordinates
tt=55-T
End Sub

'//////////////////////////////////////////////////////////
Sub BigN()	' writes BigNums using ImageArray 
Local i As Byte, j As Byte

s=str(T)
i=0
adr=VarPtr(s)   		' address of string
Do
	j=Peek(adr)   		' first num
	If j>0 Then			' until not zero (terminated)
		Incr adr       	' next
		j=j-48			' bias from ASCII  
		ImgSet(i*9+101, 0, j), BigNum2		' put on LCD
		Incr i
	Else
		Exit Do
	End If
Loop
End Sub
